HDU 2955 Robberies(01背包)

来源:互联网 发布:初学者学英语软件 编辑:程序博客网 时间:2024/06/16 09:04

Robberies

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 22743 Accepted Submission(s): 8383

Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output
2
4
6

Source
IDI Open 2009
题解:

求的就是1-被抓概率=逃跑概率,每组数据第一行是总被抓概率p(最后求得的总概率必须小于他,否则被抓),背包容量必然是钱数,然后是求最大逃跑概率,而题中每项给出的是被抓概率,所以要先被1减一下。还有最后求得的逃跑概率随着抢银行的数量增加而减少,多抢一个银行,其钱数必将转化为概率的乘积,所以动态方程也要做出改变。
然后是想抢的银行数n。然后n行,每行分别是该银行能抢的钱数m[i]和被抓的概率p[i],最后遍历,剩余的钱数越多,说明所抢的钱数越少,逃跑几率越大。所以从大到小遍历背包容量,一旦大于p,即为最大概率跳出

#include <iostream>#include <algorithm>#include <cstring>#include <cstdio>#include <cmath>using namespace std;const int maxn = 10000+5;int t;int main(){    cin>>t;    while(t--)    {        double p;        int n;        cin>>p>>n;        double sum = 0;        int cost[105];        double pp[maxn],f[maxn];        for(int i=0;i<n;i++)        {            cin>>cost[i]>>pp[i];            pp[i] = 1-pp[i];            sum += cost[i];        }        memset(f,0,sizeof(f));        f[0]=1;        for(int i=0;i<n;i++)        {            for(int j=sum;j>=cost[i];j--)            {                f[j] = max(f[j],f[j-cost[i]]*pp[i]);            }        }        for(int i=sum;i>=0;i--)        {            if(f[i]>1-p)            {                cout<<i<<endl;                break;            }        }    }    return 0;}
0 0
原创粉丝点击